#fullscreen: provides Cocoa-native fullscreen windows for Tk apps on OS X in a manner consistent with wm attributes api's. 


namespace eval fullscreen {

    if {![info exists library]} {
	variable library [file dirname [info script]]
    }

    load [file join $library libfullscreen1.2.dylib]

    image create photo _resize -data {

	R0lGODlhEAAQAIABALm5uf///yH5BAEKAAEALAAAAAAQABAAAAIhjI+gim3LXIMy
	0RpglBfghU1h5o3kNnkXp4Wtu1ZaaZoFADs=

    }

    
    proc fullscreen {windowname} {

	variable w
	set w $windowname

	fullscreen::addfullscreenbutton $w
    }

    proc togglefullscreen {} {

	variable w

	if {[wm attributes $w -fullscreen] == 1} {
	    fullscreen::restorewindow
	} else {
	    fullscreen::makefullscreen
	}
	fullscreen::fullscreen $w
    }

    proc makefullscreen {} {

	variable originalsize
	variable title
	variable w
	
	set originalsize [wm geometry $w]
	set title [wm title $w]
	
	wm withdraw $w
	wm attributes $w -fullscreen 1
	
	set m [$w cget -menu]
	
	menu $m._resize
	$m add cascade -image _resize -menu $m._resize
	$m._resize add command -label "Restore Normal Window" -command fullscreen::restorewindow
	wm deiconify $w
	
    }

    proc restorewindow {} {

	variable originalsize
	variable w
	variable title

	set m [$w cget -menu]
	$m delete end
	destroy $m._resize

	wm attributes $w  -fullscreen 0

	wm geometry . $originalsize
	wm title $w $title
	
    }

    bind all <<ToggleFullScreen>> fullscreen::togglefullscreen
    namespace export *

}






